#include"RACE_LogIndexWriter.h"
#include<unistd.h> // write(2);
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<cerrno>
#include<cstdio>
#include"output.h"

RACE_LogIndexWriter::~RACE_LogIndexWriter()
{
  if(m_fdi!=-1)
  {
    Close();
  }
}

void RACE_LogIndexWriter::Open(const char *basefilename)
{
  snprintf(m_filename,256,"%s.idx",basefilename);
  m_fdi=::open(m_filename,O_CREAT|O_WRONLY,0644);
  RACE_COND_FAIL(m_fdi<0," CLogfile::open: can't open %s:%s",m_filename,strerror(errno));
}

void RACE_LogIndexWriter::SaveOldIndex(const char *basefilename,int version)
{
  char oldname[256];
  char newname[256];
  int r;
  snprintf(oldname,256,"%s.idx",basefilename);
  snprintf(newname,256,"%s_%d.idx",basefilename,version);
  r=rename(oldname,newname);
  output::cond_error(r<0,"rename(%s,%s): %s",oldname,newname,
		    strerror(errno));
}


void RACE_LogIndexWriter::Remove(const char *basefilename,int version)
{
  char oldname[256];
  snprintf(oldname,256,"%s_%d.idx",basefilename,version);
  unlink(oldname);
}

void RACE_LogIndexWriter::WriteEntry(long unixtime,RACE_LogfileOffset offset)
{
  RACE_LogIndexLayout lie;
  lie.unixtime = unixtime;
  lie.offset   = offset;
  size_t n=::write(m_fdi,&lie,sizeof(RACE_LogIndexLayout));
  RACE_COND_FAIL(n!=sizeof(RACE_LogIndexLayout),"CLogfile::indexentry: %d instead of %d written - Index of %s corrupted",n,sizeof(RACE_LogIndexLayout),m_filename);
}

void RACE_LogIndexWriter::Close()
{
  ::close(m_fdi);
  m_fdi=-1;
}

void RACE_LogIndexWriter::Remove()
{
  unlink(m_filename);
}
