#ifndef RACE_LOGINDEXWRITER_H
#define RACE_LOGINDEXWRITER_H
#include"RACE_LogIndexLayout.h"

//##ModelId=3FB37BB50364
//##Documentation
//## Writes a Index for a Logfile (timestamp, Offset)
//## The Offset points on Snapshots
//## It writes a array of RACE_LogIndexLayout
class RACE_LogIndexWriter
{
public:
    //##ModelId=3FB37BB60366
  RACE_LogIndexWriter():m_fdi(-1) { m_filename[0]='\0'; }
    //##ModelId=3FB37BB60367
  ~RACE_LogIndexWriter();
    //##ModelId=3FB37BB60368
  void Open(const char *basefilename);
    //##ModelId=3FB37BB6036A
  //##Documentation
  //## renames an old index.idx to index_version.idx
  void SaveOldIndex(const char *basefilename,int version=1);
    //##ModelId=3FCEFDE900CC
  //##Documentation
  //## removes an old version of a indexfile
  void Remove(const char *basefilename,int version=1);
    //##ModelId=3FB37BB6036C
  void WriteEntry(long unixtime,RACE_LogfileOffset offset);
    //##ModelId=3FB37BB60375
  void Close();
    //##ModelId=3FCEFDE901FA
  //##Documentataion
  //## deletes the Indexfile
  void Remove();
private:
    //##ModelId=3FB37BB60364
  char m_filename[256];
    //##ModelId=3FB37BB60365
  int m_fdi;
};
#endif
