#include "RACE_Logfile.h"
#include<unistd.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<string.h>
#include<output.h>
#include<error.h>
//#include"logfilelayout.h"
#include<sys/mman.h> // for savelogscript

RACE_Logfile::RACE_Logfile() : m_fd(-1), mp_filename(0), m_partno(0)
{
}

RACE_Logfile::~RACE_Logfile()
{
  if(m_fd!=-1) Close();
  ::free(mp_filename);
}

void RACE_Logfile::Open(const char *filename)
{
  mp_filename=strdup(filename);

  OpenPart();
}

void RACE_Logfile::OpenPart()
{
  int filenamelen=strlen(mp_filename)+20;
  char *filename = (char *)alloca(filenamelen);
  output::cond_fail(filename==NULL,"%s:%d: alloca(%d) failed",
                    __FILE__,__LINE__,filenamelen);
  m_partno++;
  snprintf(filename,filenamelen,"%s_%d.log",mp_filename,m_partno);
  if(m_fd>0) { ::close(m_fd); }
  m_fd=::open(filename,O_CREAT|O_WRONLY,0644);
  output::cond_fail(m_fd<0," RACE_Logfile::open: can't open %s:%s",filename,strerror(errno));
}

void RACE_Logfile::Close()
{
  ::close(m_fd);m_fd=-1;
}

int RACE_Logfile::WriteV(const iovec *io,int count)
{
  return ::writev(m_fd,io,count);
}

long RACE_Logfile::PartNo()
{
   return m_partno;
}



