#ifndef RACE_LOGFILE_H
#define RACE_LOGFILE_H
#include "RACE_Accumulator.h"
#include "RACE_LogIndexWriter.h"
#include "RACE_LogfileOffset.h"

//##Documentation
//## Encapulates the writing of the Logfile
//## 
//##  splitting the Logfile in parts, 
//##  It is independed of content
class RACE_Logfile : public RACE_WriterInterface
{
  public:
    RACE_Logfile();

    virtual ~RACE_Logfile();

    void Open(const char *filename);

    //##Documentation
    //## from RACE_WriterInterface
    int WriteV(const iovec *io, int count);

    //##Documentation
    //## from RACE_WriterInterface
    virtual long PartNo();

    void Close();

    void SwitchPart() { OpenPart(); }

 private:
    void OpenPart();

    //##Documentation
    //## current Filehandle
    int m_fd;

    char *mp_filename;

    int m_partno;
};



#endif /* RACE_LOGFILE_H */
