#ifndef RACE_THREAD_H
#define RACE_THREAD_H
#include<ace/Thread_Manager.h>
#include"envdebug.h"

//##ModelId=3ED2278F013F
//##Documentation
//## Simple wrapper for thread class with reference counting.
//## The thread reference count starts with one.
//## The child has to overwrite the run method.
class RACE_Thread
{
public:
    //##ModelId=3ED22792027D
  RACE_Thread():thread_group_id(-1),refcount_(1) {}
    //##ModelId=3ED22792027E
  void start();
    //##ModelId=3ED227920287
  void release();
    //##ModelId=3FC5CFD70293
  int number_of_refs();
    //##ModelId=3ED227920288
  RACE_Thread *duplicate();
 
protected:
    //##ModelId=3FC5CFD70284
  static envdebug *debug;
    //##ModelId=3ED227920289
  virtual void run() = 0;
    //##ModelId=3ED22792028B
  virtual ~RACE_Thread();
private:
    //##ModelId=3FC5CFD70292
  int thread_group_id;
    //##ModelId=3ED22792028D
  static void *proc_to_run(void *myself);
  ACE_Thread_Mutex refcount_mutex_;
    //##ModelId=3ED22792027C
  int refcount_;
};
#endif
