#include "output.h"

int
main (int, char** argv)
{
  try {
    output::message ("%s: message with automatically determined executable_name", argv[0]);
    output::set_executable_name ("Manual_Set_Executable_Name");
    output::warn ("%s: warning with given executable_name", argv[0]);
    {
      output::component c ("Manual_Set_Component_Name::outer");
      output::time_output_on ();
      c.warn ("%s: warning with activated time output and given component_name", argv[0]);
      {
        output::component inner ("Manual_Set_Component_Name::inner");
        inner.message ("message from inner component");
      }
      c.message ("message from outer component after destruction of inner.");
    }
    output::message ("message after destruction of the output::component object");
  }
  catch (...) {
    output::fail ("%s: got unexpected exception", argv[0]);
  }
  return 0;
}
