#include "string_parser.h"

string_list_parser::StringVector
string_list_parser::splitValues (char delimiter) const
{
  std::string input = get_str ();
  StringVector outlist; // start with empty vector

  if (! input.empty ()) {
    std::string::size_type start_pos = 0;
    const std::string::size_type len = input.length ();
    do {
      std::string::size_type end_pos = input.find_first_of (delimiter, start_pos);
      if (end_pos >= len) {
        outlist.push_back (input.substr (start_pos));
        break;
      }
      outlist.push_back (input.substr (start_pos, end_pos - start_pos));
      start_pos = end_pos + 1;
    } while (start_pos < len);
    if (input[len - 1] == delimiter) {
      outlist.push_back ("");
    }
  }
  return outlist;
}

string_list_parser::StringVector
string_list_parser::splitAndPruneValues (bool& emptyValuesEncountered, char delimiter) const
{
  emptyValuesEncountered = false;
  StringVector outlist; // start with empty vector
  StringVector tmplist = splitValues (delimiter);
  for (unsigned i = 0; i < tmplist.size (); i++) {
    if (tmplist[i].empty ())
      emptyValuesEncountered = true;
    else
      outlist.push_back (tmplist[i]);
  }
  return outlist;
}

bool
string_flag_parser::is_on ()
{
  if (! switch_state_checked) {
    std::string input = get_str ();
    if (input.empty () || (input.compare ("0") == 0))
      switch_is_on = false;
    else
      switch_is_on = true;
    switch_state_checked = true;
  }
  return switch_is_on;
}

unsigned long
string_level_parser::level ()
{
  if (! switch_level_checked) {
    switch_level = 0; // This is the default.
    std::string input = get_str ();
    if (! input.empty ()) {
      unsigned long conversion_level = strtoul (input.c_str (), (char **)NULL, 10);
      if ((conversion_level != 0) && (conversion_level != ULONG_MAX))
        switch_level = conversion_level;
    }
    switch_level_checked = true;
  }
  return switch_level;
}

bool
string_level_parser::is_on ()
{
  return (level () != 0);
}

